<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: siggen::MTSignatures Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classsiggen_1_1_m_t_signatures.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classsiggen_1_1_m_t_signatures-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">siggen::MTSignatures Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>thread-safe buffer for resulting block-wise signatures  
 <a href="classsiggen_1_1_m_t_signatures.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_m_t_signatures_8h_source.html">MTSignatures.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a15d4f98f366679e90a036e44cc422ad2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_signatures.html#a15d4f98f366679e90a036e44cc422ad2">MTSignatures</a> (size_t blockCount, size_t hashSize)</td></tr>
<tr class="memdesc:a15d4f98f366679e90a036e44cc422ad2"><td class="mdescLeft">&#160;</td><td class="mdescRight">pre-allocates blockCount*hashSize bytes of memory  <a href="classsiggen_1_1_m_t_signatures.html#a15d4f98f366679e90a036e44cc422ad2">More...</a><br /></td></tr>
<tr class="separator:a15d4f98f366679e90a036e44cc422ad2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c0c1ca006f51e67e167d9be74662a95"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">PostResult</a> (size_t blockIndex, result_t const &amp;blockSignature)</td></tr>
<tr class="memdesc:a8c0c1ca006f51e67e167d9be74662a95"><td class="mdescLeft">&#160;</td><td class="mdescRight">posting result from another thread  <a href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">More...</a><br /></td></tr>
<tr class="separator:a8c0c1ca006f51e67e167d9be74662a95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab926d14daa29ab9c4ff06ff8545e0b34"><td class="memItemLeft" align="right" valign="top"><a id="ab926d14daa29ab9c4ff06ff8545e0b34"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_signatures.html#ab926d14daa29ab9c4ff06ff8545e0b34">WaitForComplete</a> ()</td></tr>
<tr class="memdesc:ab926d14daa29ab9c4ff06ff8545e0b34"><td class="mdescLeft">&#160;</td><td class="mdescRight">waits on the condition until all threads deliver their result <br /></td></tr>
<tr class="separator:ab926d14daa29ab9c4ff06ff8545e0b34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aefefb4578dd0a3af71eb81148fe9fa16"><td class="memItemLeft" align="right" valign="top"><a id="aefefb4578dd0a3af71eb81148fe9fa16"></a>
const result_t &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">GetResult</a> () const</td></tr>
<tr class="memdesc:aefefb4578dd0a3af71eb81148fe9fa16"><td class="mdescLeft">&#160;</td><td class="mdescRight">get array with result signatures of each block of input <br /></td></tr>
<tr class="separator:aefefb4578dd0a3af71eb81148fe9fa16"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a19341613e5b456f7d8ef16893726bc16"><td class="memItemLeft" align="right" valign="top"><a id="a19341613e5b456f7d8ef16893726bc16"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_signatures.html#a19341613e5b456f7d8ef16893726bc16">IsComplete</a> () const</td></tr>
<tr class="memdesc:a19341613e5b456f7d8ef16893726bc16"><td class="mdescLeft">&#160;</td><td class="mdescRight">all of the block signatures arrived <br /></td></tr>
<tr class="separator:a19341613e5b456f7d8ef16893726bc16"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>thread-safe buffer for resulting block-wise signatures </p>

<p class="definition">Definition at line <a class="el" href="_m_t_signatures_8h_source.html#l00011">11</a> of file <a class="el" href="_m_t_signatures_8h_source.html">MTSignatures.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a15d4f98f366679e90a036e44cc422ad2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15d4f98f366679e90a036e44cc422ad2">&#9670;&nbsp;</a></span>MTSignatures()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">siggen::MTSignatures::MTSignatures </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>hashSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>pre-allocates blockCount*hashSize bytes of memory </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockCount</td><td>size of the input file in blocks </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">hashSize</td><td>size of the signature (digest) in bytes </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_m_t_signatures_8cpp_source.html#l00007">7</a> of file <a class="el" href="_m_t_signatures_8cpp_source.html">MTSignatures.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a8c0c1ca006f51e67e167d9be74662a95"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c0c1ca006f51e67e167d9be74662a95">&#9670;&nbsp;</a></span>PostResult()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void siggen::MTSignatures::PostResult </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">result_t const &amp;&#160;</td>
          <td class="paramname"><em>blockSignature</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>posting result from another thread </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockIndex</td><td>index of the block of data </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blockSignature</td><td>signature (digest) of the block corresponding to blockIndex </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_m_t_signatures_8cpp_source.html#l00014">14</a> of file <a class="el" href="_m_t_signatures_8cpp_source.html">MTSignatures.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/x/siggen/lib/include/<a class="el" href="_m_t_signatures_8h_source.html">MTSignatures.h</a></li>
<li>/home/x/siggen/lib/src/<a class="el" href="_m_t_signatures_8cpp_source.html">MTSignatures.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>siggen</b></li><li class="navelem"><a class="el" href="classsiggen_1_1_m_t_signatures.html">MTSignatures</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
